package cn.usr.www.usrapirefcode.Activities;

import android.os.Bundle;
import android.support.annotation.Nullable;
import android.support.v7.app.AppCompatActivity;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;


import com.usr.rkapi.MyManager;


import Utiles.UsrLog;
import cn.usr.www.usrapirefcode.Activities.baseClass.UsrBaseActivity;
import cn.usr.www.usrapirefcode.R;

public class ExternalStoreExample extends UsrBaseActivity implements View.OnClickListener {
    private final String TAG = "ExternalStoreExample";

    private EditText et_mount_path;
    private Button bt_mount_dev;

    private EditText et_umount_path;
    private Button bt_umount_dev;

    private TextView tv_sd_path;
    private TextView tv_usb_path;

    /*获取服务实例化对象*/
    MyManager myManager = MyManager.getInstance(this);

    @Override
    protected void usrSetContentView() {

        setContentView(R.layout.external_store_example_activity);
    }

    @Override
    protected void usrInitShowDatas() {
        showSDcardPath();
        showUSBPath();
        showUSBPathTest();
    }

    @Override
    protected void usrInitComponent() {

        et_mount_path = (EditText)findViewById(R.id.et_mount_path);
        bt_mount_dev = (Button)findViewById(R.id.bt_mount_dev);

        et_umount_path = (EditText)findViewById(R.id.et_umount_path);
        bt_umount_dev = (Button)findViewById(R.id.bt_umount_dev);
        tv_sd_path = (TextView)findViewById(R.id.tv_sd_path);
        tv_usb_path = (TextView)findViewById(R.id.tv_usb_path);
        /*设置监听事件*/
        bt_mount_dev.setOnClickListener(this);
        bt_umount_dev.setOnClickListener(this);

    }



    private void showSDcardPath(){

        String sdPath = myManager.getSDcardPath();
        UsrLog.LOGD(TAG, "sdPath = "+sdPath);

        if((sdPath == null)||sdPath.equals("")){
            sdPath = "null";
        }
        tv_sd_path.setText(sdPath);
    }

    private void showUSBPathTest(){

        String usbPath0 = myManager.getUSBStoragePath(0);
        UsrLog.LOGD(TAG, "usbPath0 = "+usbPath0);
        String usbPath1 = myManager.getUSBStoragePath(1);
        UsrLog.LOGD(TAG, "usbPath1 = "+usbPath1);
        String usbPath2 = myManager.getUSBStoragePath(2);
        UsrLog.LOGD(TAG, "usbPath2 = "+usbPath2);
        String usbPath3 = myManager.getUSBStoragePath(3);
        UsrLog.LOGD(TAG, "usbPath3 = "+usbPath3);
        String usbPath4 = myManager.getUSBStoragePath(4);
        UsrLog.LOGD(TAG, "usbPath4 = "+usbPath4);

    }


    private void showUSBPath(){

        String usbPath = myManager.getUSBStoragePath(0);
        UsrLog.LOGD(TAG, "usbPath = "+usbPath);

        if((usbPath == null)||usbPath.equals("")){
            usbPath = "null";
        }
        tv_usb_path.setText(usbPath);
    }

    @Override
    public void onClick(View view) {
        switch (view.getId()){
            case R.id.bt_mount_dev:{
                mountDev();
                break;
            }
            case R.id.bt_umount_dev:{
                uMountDev();
                break;
            }
            default:{
                break;
            }
        }
    }

    private void mountDev(){

        CharSequence mountPath = et_mount_path.getText();
        if(mountPath == null){
            Toast.makeText(this, "输入要挂载的路径", Toast.LENGTH_LONG).show();
            UsrLog.LOGE(TAG, "输入要挂载的路径");
            return;
        }

        myManager.mountVolume(mountPath.toString());

    }

    private void uMountDev(){

        CharSequence umountPath = et_umount_path.getText();
        if(umountPath == null){
            Toast.makeText(this, "输入要卸载的路径", Toast.LENGTH_LONG).show();
            UsrLog.LOGE(TAG, "输入要卸载的路径");
            return;

        }
        myManager.unmountVolume(umountPath.toString());
    }
}
