package cn.usr.www.usrapirefcode.Activities;

import android.os.Bundle;
import android.support.annotation.Nullable;
import android.support.v7.app.AppCompatActivity;
import android.view.View;
import android.widget.Button;
import android.widget.CompoundButton;
import android.widget.EditText;
import android.widget.Switch;
import android.widget.Toast;


import com.usr.rkapi.MyManager;


import Utiles.UsrLog;
import cn.usr.www.usrapirefcode.Activities.baseClass.UsrBaseActivity;
import cn.usr.www.usrapirefcode.R;

public class OtherOprExample extends UsrBaseActivity implements View.OnClickListener{
    private final String TAG = "OtherOprExample";

    private EditText et_year;
    private EditText et_month;
    private EditText et_day;
    private EditText et_hour;
    private EditText et_minute;
    private Button bt_set_time;
    private Switch sw_auto_upgrade_time;
    private Button bt_exe_cmd;
    private EditText et_cmd;

    private MyManager myManager = MyManager.getInstance(this);

    @Override
    protected void usrSetContentView() {
        setContentView(R.layout.other_opr_example_activity);
    }

    @Override
    protected void usrInitComponent() {
        et_year = (EditText)findViewById(R.id.et_year);
        et_month = (EditText)findViewById(R.id.et_month);
        et_day = (EditText)findViewById(R.id.et_day);
        et_hour = (EditText)findViewById(R.id.et_hour);
        et_minute = (EditText)findViewById(R.id.et_minute);
        bt_set_time = (Button)findViewById(R.id.bt_set_time);
        et_cmd = (EditText)findViewById(R.id.et_cmd);
        bt_exe_cmd = (Button)findViewById(R.id.bt_exe_cmd);
        sw_auto_upgrade_time= (Switch)findViewById(R.id.sw_auto_upgrade_time);

        bt_set_time.setOnClickListener(this);
        bt_exe_cmd.setOnClickListener(this);

        /*时间自动更新状态监听*/
        sw_auto_upgrade_time.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton compoundButton, boolean b) {
                UsrLog.LOGD(TAG, "设置自动更新时间：b = "+b);
                myManager.switchAutoTime(b);
            }
        });

    }

    @Override
    protected void usrInitShowDatas() {
        boolean isAutoSyncTime = myManager.isAutoSyncTime();
        UsrLog.LOGD(TAG, "isAutoSyncTime:"+isAutoSyncTime);
    }

    @Override
    public void onClick(View view) {
        switch (view.getId()){
            case R.id.bt_set_time:{

                setUsrTime();
                break;
            }
            case R.id.bt_exe_cmd:{

                runShellCmd();
                break;
            }
            default:{
                break;
            }
        }
    }

    private void runShellCmd(){
        CharSequence cmd = et_cmd.getText();
        if(cmd != null){
            String cmdStr = cmd.toString();
            UsrLog.LOGD(TAG, "cmdStrd = "+cmdStr);
            myManager.execSuCmd(cmdStr);
        }
    }
    private void setUsrTime(){
        CharSequence  year = et_year.getText();
        CharSequence  month = et_month.getText();
        CharSequence  day = et_day.getText();
        CharSequence  hour = et_hour.getText();
        CharSequence  minute = et_minute.getText();

        if((year ==null)||(month ==null)||(day ==null)||(hour ==null)||(minute ==null)){
            Toast.makeText(this, "请正确填写信息", Toast.LENGTH_LONG).show();
            return ;
        }

        int yearInt =  Integer.valueOf(year.toString());
        int monthInt =  Integer.valueOf(month.toString());
        int dayInt =  Integer.valueOf(day.toString());
        int hourInt =  Integer.valueOf(hour.toString());
        int minuteInt =  Integer.valueOf(minute.toString());

        UsrLog.LOGD(TAG, "yearInt = "+yearInt+" monthInt = "+monthInt
        +"dayInt = "+dayInt+" hourInt = "+hourInt
        +"minuteInt = "+minuteInt);

        myManager.setTime(yearInt,
                monthInt,
                dayInt,
                hourInt,
                minuteInt);
    }
}
