package cn.usr.www.usrapirefcode.Activities;

import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

import Utiles.NumberUtils;
import Utiles.UsrLog;
import cn.usr.www.usrapirefcode.Activities.baseClass.UsrBaseActivity;
import cn.usr.www.usrapirefcode.R;
import startest.usr.com.poweronoff.PowerOnOffManager;

public class TimerExample extends UsrBaseActivity implements View.OnClickListener{
    private final String TAG = "TimerExample";

    private TextView  tv_timer_api_version;
    private TextView tv_timer_mode;

    /*定时开关机*/
    private EditText et_poweroff_once;
    private EditText et_poweron_once;
    private EditText et_poweroff_weekly;
    private EditText et_poweron_weekly;
    private EditText et_weekly_frequery;
    private Button bt_poweroffon_once_submit;
    private Button bt_poweroffon_weekly_submit;
    private Button bt_clear_poweroffon_time;

    private TextView tv_lastest_power_on_time;
    private TextView tv_lastest_power_off_time;

    private PowerOnOffManager manager = PowerOnOffManager.getInstance(this);


    @Override
    protected void usrSetContentView() {
        setContentView(R.layout.timer_example_activity);
    }

    @Override
    protected void usrInitComponent() {
        tv_timer_api_version = (TextView)findViewById(R.id.tv_timer_api_version);
        tv_timer_mode = (TextView)findViewById(R.id.tv_timer_mode);
        /*定时开关机，只一次*/
        et_poweroff_once = (EditText)findViewById(R.id.et_poweroff_once);
        et_poweron_once = (EditText)findViewById(R.id.et_poweron_once);
        bt_poweroffon_once_submit = (Button)findViewById(R.id.bt_poweroffon_once_submit);
        /*定时开关机，周期性*/
        et_poweroff_weekly = (EditText)findViewById(R.id.et_poweroff_weekly);
        et_poweron_weekly = (EditText)findViewById(R.id.et_poweron_weekly);
        bt_poweroffon_weekly_submit = (Button)findViewById(R.id.bt_poweroffon_weekly_submit);
        et_weekly_frequery = (EditText)findViewById(R.id.et_weekly_frequery);
        bt_clear_poweroffon_time = (Button)findViewById(R.id.bt_clear_poweroffon_time);

        tv_lastest_power_on_time = (TextView)findViewById(R.id.tv_lastest_power_on_time);
        tv_lastest_power_off_time = (TextView)findViewById(R.id.tv_lastest_power_off_time);

        bt_poweroffon_once_submit.setOnClickListener(this);
        bt_poweroffon_weekly_submit.setOnClickListener(this);
        bt_clear_poweroffon_time.setOnClickListener(this);
    }

    @Override
    protected void usrInitShowDatas() {
        powerOnOffMgVersionShow();
        powerOnOffMgModeShow();
        powerOnOffTimeShow();
        lastestPowerInfoShow();
    }

    private void lastestPowerInfoShow(){
        String lastestPowerOnTime = manager.getLastestPowerOnTime();
        String lastestPowerOffTime = manager.getLastestPowerOffTime();

        if(lastestPowerOnTime == null) lastestPowerOnTime = "null";
        if(lastestPowerOffTime == null) lastestPowerOffTime = "null";

        tv_lastest_power_on_time.setText(lastestPowerOnTime);
        tv_lastest_power_off_time.setText(lastestPowerOffTime);
    }

    private void powerOnOffTimeShow(){
        String powerOnTime = manager.getPowerOnTime();
        String powerOFFTime = manager.getPowerOffTime();
        if(powerOnTime == null) powerOFFTime = "null";
        if(powerOFFTime == null) powerOFFTime = "null";

        et_poweron_once.setHint(powerOnTime);
        et_poweroff_once.setHint(powerOFFTime);
        et_poweron_weekly.setHint(powerOnTime);
        et_poweroff_weekly.setHint(powerOFFTime);
    }
    private void powerOnOffMgVersionShow(){

        String apiVersion = manager.getVersion();
        UsrLog.LOGD(TAG, "apiVersion = "+apiVersion);
        tv_timer_api_version.setText(apiVersion);
    }

    private void powerOnOffMgModeShow(){

        String timerMode = manager.getPowerOnMode();
        if(timerMode.equals("1")){
            timerMode = "once";
        }else if(timerMode.equals("2")){
            timerMode = "weekly";
        }else{
            timerMode = "null";
        }
        tv_timer_mode.setText(timerMode);
    }


    @Override
    public void onClick(View view) {

        switch (view.getId()){
            case R.id.bt_poweroffon_once_submit:{
                setPowerOffOnOnce();
                break;
            }
            case R.id.bt_poweroffon_weekly_submit:{
                setPowerOffOnWeekly();
                break;
            }
            case R.id.bt_clear_poweroffon_time:{

                manager.clearPowerOnOffTime();

                break;
            }
            default:{
                break;
            }
        }
    }

    private void setPowerOffOnOnce(){
        CharSequence powerOffOnceTimer = et_poweroff_once.getText();
        CharSequence powerOnOnceTimer = et_poweron_once.getText();

        if((powerOffOnceTimer ==null)||(powerOnOnceTimer == null)){
            Toast.makeText(this, "请输入正确的开关机时间", Toast.LENGTH_LONG).show();
            return;
        }
        manager.setPowerOnOff(NumberUtils.StringtoInt(powerOnOnceTimer.toString()), NumberUtils.StringtoInt(powerOffOnceTimer.toString()));
    }

    private void setPowerOffOnWeekly(){
        CharSequence powerOffWeeklyTimer = et_poweroff_weekly.getText();
        CharSequence powerOnWeeklyTimer = et_poweron_weekly.getText();
        CharSequence weeklyFrequery = et_weekly_frequery.getText();

        if((powerOffWeeklyTimer ==null)||(powerOnWeeklyTimer == null)||(weeklyFrequery == null)){
            Toast.makeText(this, "请输入正确的周期开关机参数", Toast.LENGTH_LONG).show();
            return;
        }
        manager.setPowerOnOffWithWeekly(NumberUtils.StringtoInt(powerOnWeeklyTimer.toString()),
                NumberUtils.StringtoInt(powerOffWeeklyTimer.toString()),NumberUtils.StringtoInt(weeklyFrequery.toString()));
    }
}
