package cn.usr.www.usrapirefcode.Activities;


import android.text.InputType;
import android.view.View;
import android.widget.Button;
import android.widget.CompoundButton;
import android.widget.EditText;
import android.widget.RadioGroup;
import android.widget.Switch;
import android.widget.TextView;
import android.widget.Toast;


import com.usr.rkapi.MyManager;


import Utiles.UsrLog;
import cn.usr.www.usrapirefcode.Activities.baseClass.UsrBaseActivity;
import cn.usr.www.usrapirefcode.R;

public class UsrAboutDisplayer extends UsrBaseActivity implements View.OnClickListener{

    private final String TAG ="UsrAboutDisplayer";

    private final String defaultScreenShotStorePath ="/sdcard/Pictures/ganye.jpg";

    /*组件申明*/
    private Button bt_screenshot ;
    private TextView tv_dispalyer_width;
    private TextView tv_dispalyer_height;

    private RadioGroup rg_rotate_values;
    private Button bt_rotate_screen_confirm;
    private Switch sw_hide_nav_bar;
    private Switch sw_slide_nav_bar;
    private Switch sw_slide_Notification_bar;
    private Switch sw_backlight;
    private Switch sw_hdmi_out;
    private EditText et_screenshot_path;
    private EditText  et_screenshot_file_name;


    MyManager myManager = MyManager.getInstance(this);

    @Override
    protected void usrSetContentView() {
        setContentView(R.layout.about_display_activity);
    }

    @Override
    protected void usrInitComponent() {
        bt_screenshot = (Button)findViewById(R.id.bt_screenshot);

        rg_rotate_values = (RadioGroup)findViewById(R.id.rg_rotate_values);
        bt_rotate_screen_confirm = (Button)findViewById(R.id.bt_rotate_screen_confirm);
        tv_dispalyer_width  = (TextView)findViewById(R.id.tv_dispalyer_width);
        tv_dispalyer_height  = (TextView)findViewById(R.id.tv_dispalyer_height);
        sw_hide_nav_bar = (Switch)findViewById(R.id.sw_hide_nav_bar);
        sw_slide_nav_bar = (Switch)findViewById(R.id.sw_slide_nav_bar);
        sw_slide_Notification_bar = (Switch)findViewById(R.id.sw_slide_Notification_bar);
        sw_backlight = (Switch)findViewById(R.id.sw_backlight);
        sw_hdmi_out = (Switch)findViewById(R.id.sw_hdmi_out);
        et_screenshot_path = (EditText)findViewById(R.id.et_screenshot_path);
        et_screenshot_file_name = (EditText)findViewById(R.id.et_screenshot_file_name);


        et_screenshot_path.setInputType(InputType.TYPE_NULL);
        et_screenshot_file_name.setInputType(InputType.TYPE_NULL);

        /*设置监听器*/
        bt_screenshot.setOnClickListener(this);
        bt_rotate_screen_confirm.setOnClickListener(this);


        /*背光开关事件监听*/
        sw_backlight.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton compoundButton, boolean b) {

                setUsrBackLight(b);
            }
        });

        /*HDMI输出事件监听*/
        sw_hdmi_out.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton compoundButton, boolean b) {

                setUsrHdmiOut(b);
            }
        });
        /*导航栏状态监听器*/
        sw_hide_nav_bar.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton compoundButton, boolean b) {

                UsrLog.LOGD(TAG, "显示虚拟按键"+b);
                myManager.hideNavBar(b);

            }
        });
        /*滑动导航栏监听器*/
        sw_slide_nav_bar.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton compoundButton, boolean b) {
                UsrLog.LOGD(TAG, "禁止滑出导航栏:"+b);
                myManager.setSlideShowNavBar(b);
            }
        });

        /*滑动通知栏监听事件*/
        sw_slide_Notification_bar.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton compoundButton, boolean b) {
                UsrLog.LOGD(TAG, "禁止滑出通知栏:"+b);
                myManager.setSlideShowNotificationBar(b);
            }
        });
    }

    @Override
    protected void usrInitShowDatas() {
        displayerResolutionShow();
        showHideNavBarStatus();
        showSlideNavBarStatus();
        showSlideNotificationBarStatus();
    }

    /*显示是否支持滑动通知栏*/
    private void showSlideNotificationBarStatus(){

        sw_slide_nav_bar.setChecked(myManager.isSlideShowNotificationBarOpen());
    }

    /*显示是否支持滑动导航栏*/
    private void showSlideNavBarStatus(){

        sw_slide_nav_bar.setChecked(myManager.isSlideShowNavBarOpen());
    }
    /*显示导航栏状态*/
    private void  showHideNavBarStatus(){

        sw_hide_nav_bar.setChecked(myManager.getNavBarHideState());


    }

    /*显示分辨率*/
    private void displayerResolutionShow(){

        int dispalyeWidth = myManager.getDisplayWidth(this);
        int dispalyeHeight = myManager.getDisplayHeight(this);
        UsrLog.LOGD(TAG, "dispalyeWidth:"+dispalyeWidth+" dispalyeHeight"+dispalyeHeight);
        tv_dispalyer_width.setText(dispalyeWidth+"");
        tv_dispalyer_height.setText(dispalyeHeight+"");
    }

    private void initComponent(){



    }




    @Override
    public void onClick(View view) {

        switch (view.getId()){
            case R.id.bt_screenshot:{
                    if(myManager != null){
                        myManager.takeScreenshot(getScreenStorePath());
                        Toast.makeText(this, "截图成功！！", Toast.LENGTH_LONG).show();
                    }
                break;
            }
            case R.id.bt_rotate_screen_confirm:{

                if(myManager != null){

                    String degree = getScreenRotate();
                    UsrLog.LOGD(TAG, "degree = "+degree);
                    myManager.rotateScreen(this, degree);

                    Toast.makeText(this, "屏幕旋转:"+degree, Toast.LENGTH_LONG).show();
                }
            }
        }
    }

    private String getScreenStorePath(){
        CharSequence screenshotPath = et_screenshot_path.getText();
        CharSequence screenshotFileName = et_screenshot_file_name.getText();
        if(screenshotPath ==null || screenshotFileName ==null){
            Toast.makeText(this, "请填入正确的路径及文件名", Toast.LENGTH_LONG).show();
            return defaultScreenShotStorePath;
        }
        return screenshotPath.toString().trim()+"/"+screenshotFileName.toString().trim();

    }


    private String getScreenRotate(){

        int id = rg_rotate_values.getCheckedRadioButtonId();
        String degree = null;
        switch (id){
            case R.id.rb_rotate_0:{
                degree =  "0";
                break;
            }
            case R.id.rb_rotate_90:{
                degree =  "90";
                break;
            }
            case R.id.rb_rotate_180:{
                degree =  "180";
                break;
            }
            case R.id.rb_rotate_270:{
                degree =  "270";
                break;
            }
            default:{
                degree =  "0";
                break;
            }
        }

        return degree;
    }

    private void setUsrBackLight(boolean  enable){

        Toast.makeText(this, "setUsrBackLight:enable = "+enable,Toast.LENGTH_LONG).show();
        if(enable){
            myManager.turnOnBacklight();
        }else {
            myManager.turnOffBacklight();
        }
    }

    private void setUsrHdmiOut(boolean  enable){

        Toast.makeText(this, "setUsrHdmiOut:enable = "+enable,Toast.LENGTH_LONG).show();
        if(enable){
            myManager.turnOnHDMI();
        }else {
            myManager.turnOffHDMI();
        }
    }
}

