package cn.usr.www.usrapirefcode.Activities;

import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

import com.usr.rkapi.MyManager;


import Utiles.UsrLog;
import cn.usr.www.usrapirefcode.Activities.baseClass.UsrBaseActivity;
import cn.usr.www.usrapirefcode.R;

public class UsrLogStoreExample extends UsrBaseActivity implements View.OnClickListener{

    private final String TAG = "UsrLogStoreExample";

    private MyManager myManager = MyManager.getInstance(this);

    private EditText et_android_log_store_path;
    private EditText et_kernel_log_store_path;
    private Button bt_confirm_android_log_sotre;
    private Button bt_confirm_kernel_log_sotre;

    @Override
    protected void usrSetContentView() {

        setContentView(R.layout.usr_log_store_example);
    }

    @Override
    protected void usrInitShowDatas() {

    }

    @Override
    protected void usrInitComponent() {
        et_android_log_store_path = (EditText) findViewById(R.id.et_android_log_store_path);
        et_kernel_log_store_path = (EditText) findViewById(R.id.et_kernel_log_store_path);
        bt_confirm_android_log_sotre  = (Button)findViewById(R.id.bt_confirm_android_log_sotre);
        bt_confirm_kernel_log_sotre   = (Button)findViewById(R.id.bt_confirm_kernel_log_sotre);

        bt_confirm_android_log_sotre.setOnClickListener(this);
        bt_confirm_kernel_log_sotre.setOnClickListener(this);
        findViewById(R.id.bt_stop_android_log_sotre).setOnClickListener(this);
    }

    @Override
    public void onClick(View view) {
        switch (view.getId()){
            case R.id.bt_confirm_android_log_sotre:{
                UsrLog.LOGD(TAG, "bt_confirm_android_log_sotre");
                storeAndroidLog();

                break;
            }
            case R.id.bt_confirm_kernel_log_sotre:{
                UsrLog.LOGD(TAG, "bt_confirm_kernel_log_sotre");
                storeKernelLog();
                break;
            }
            case R.id.bt_stop_android_log_sotre:{
                UsrLog.LOGD(TAG, "bt_confirm_kernel_log_sotre");
                myManager.stopAndroidLogcat();
                break;
            }
        }
    }

    /*ANDROID LOG*/
    private void storeAndroidLog(){

        String androidSotrePath =  getAndroidStorePath();
        UsrLog.LOGD(TAG, "androidSotrePath = "+androidSotrePath);
        myManager.getAndroidLogcat(androidSotrePath);
        Toast.makeText(this, "Android Log 将持续写入"+androidSotrePath+",关闭请使用stopAndroidLogcat接口",Toast.LENGTH_LONG).show();
        //myManager.getAndroidLogcat("/scard/android-log.txt");
    }

    private String getAndroidStorePath(){

        CharSequence pathTmp = et_android_log_store_path.getText();

        if(pathTmp == null){
            UsrLog.LOGE(TAG, "pathTmp  = "+pathTmp);
            return "null";
        }
        return pathTmp.toString();
    }

    /*KERNEL LOG*/
    private void storeKernelLog(){

        String kernelSotrePath =  getKernelStorePath();
        UsrLog.LOGD(TAG, "kernelSotrePath = "+kernelSotrePath);
        myManager.getKmsgLog(kernelSotrePath);
//        myManager.getKmsgLog("/sdcard/kernel-log.txt");
    }

    private String getKernelStorePath(){

        CharSequence kernelPathTmp = et_kernel_log_store_path.getText();

        if(kernelPathTmp == null){
            UsrLog.LOGE(TAG, "kernelPathTmp  = "+kernelPathTmp);
            return "null";
        }
        return kernelPathTmp.toString();
    }
}
