package cn.usr.www.usrapirefcode.Activities;

import android.content.DialogInterface;

import android.support.v7.app.AlertDialog;

import android.view.View;
import android.widget.Button;


import com.usr.rkapi.MyManager;


import Utiles.UsrLog;
import cn.usr.www.usrapirefcode.Activities.baseClass.UsrBaseActivity;
import cn.usr.www.usrapirefcode.R;

public class UsrShutdownReboot extends UsrBaseActivity implements View.OnClickListener{

    private final String TAG = "UsrShutDownReboot";

    private final String OPR_CONFIRM_TILE = "CONFIRM";

    MyManager mMyManager = MyManager.getInstance(this);
    private Button bt_shutdown;
    private Button bt_reboot;

    @Override
    protected void usrSetContentView() {
        setContentView(R.layout.shutdown_reboot_activity);
    }

    @Override
    protected void usrInitComponent() {
        bt_shutdown = (Button)findViewById(R.id.bt_shutdown);
        bt_reboot = (Button)findViewById(R.id.bt_reboot);

        /*set listener*/
        bt_shutdown.setOnClickListener(this);
        bt_reboot.setOnClickListener(this);
        findViewById(R.id.bt_reboot_to_recovery).setOnClickListener(this);
    }

    @Override
    protected void usrInitShowDatas() {

    }


    @Override
    public void onClick(View view) {

        switch (view.getId()){

            case R.id.bt_shutdown:{

                isShutDown();
                break;
            }

            case R.id.bt_reboot:{
                isReboot();
                break;
            }
            case R.id.bt_reboot_to_recovery:{

                isRebootToRecovery();
                break;
            }
        }
    }


    private void isShutDown(){

        new AlertDialog.Builder(this)
                .setTitle("shutdown?")
                .setPositiveButton("是的", new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialogInterface, int i) {
                        UsrLog.LOGD(TAG, "shutdown!!");
                        if(mMyManager != null){

                            mMyManager.shutdown();

                        }
                    }
                })
                .create().show();

    }


    private void isReboot(){

        new AlertDialog.Builder(this)
                .setTitle("reboot ?")
                .setPositiveButton("是的", new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialogInterface, int i) {
                        UsrLog.LOGD(TAG, "reboot!!");
                        if(mMyManager != null){

                            mMyManager.reboot();

                        }
                    }
                })
                .create().show();

    }

    private void isRebootToRecovery(){

        new AlertDialog.Builder(this)
                .setTitle("reboot to recovery?")
                .setPositiveButton("是的", new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialogInterface, int i) {
                        UsrLog.LOGD(TAG, "reboot to recovery!!");
                        if(mMyManager != null){

                            mMyManager.rebootRecovery();

                        }
                    }
                })
                .create().show();

    }

}
