package cn.usr.www.usrapirefcode.Activities;

import android.content.Intent;
import android.os.Handler;
import android.text.InputType;
import android.view.View;
import android.view.WindowManager;
import android.widget.EditText;
import android.widget.Toast;

import com.usr.mcu7502.Mcu7502;

import Utiles.UsrLog;
import cn.usr.www.usrapirefcode.Activities.baseClass.UsrBaseActivity;
import cn.usr.www.usrapirefcode.R;

public class UsrWatchDogExample extends UsrBaseActivity implements View.OnClickListener{

    private final String TAG = "UsrWatchDogExample";

    private Handler handler;
    private Handler testHandler;
    private EditText et_open_time;
    private EditText et_feed_dog_time;

    @Override
    protected void usrSetContentView() {

        setContentView(R.layout.usr_watch_dog_example);
    }

    @Override
    protected void usrInitComponent() {

        findViewById(R.id.bt_open_watchDog).setOnClickListener(this);
        findViewById(R.id.bt_close_watchDog).setOnClickListener(this);
        findViewById(R.id.bt_feed_dog).setOnClickListener(this);
        findViewById(R.id.bt_reset).setOnClickListener(this);
        findViewById(R.id.bt_get_watchdog_status).setOnClickListener(this);
        findViewById(R.id.bt_get_version).setOnClickListener(this);
        findViewById(R.id.bt_set_time).setOnClickListener(this);
        findViewById(R.id.bt_shutdown).setOnClickListener(this);
        findViewById(R.id.bt_feed_dog_one_time).setOnClickListener(this);
        findViewById(R.id.bt_test).setOnClickListener(this);
        et_open_time = (EditText) findViewById(R.id.et_open_time);
        et_feed_dog_time = (EditText) findViewById(R.id.et_feed_dog_time);

        handler = new Handler();
        testHandler = new Handler();

        int a = Mcu7502.open();
        UsrLog.LOGD(TAG, "open::" + a);

        softInputStateHidden();

    }


    private void softInputStateHidden(){

        getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_HIDDEN);
        et_feed_dog_time.setInputType(InputType.TYPE_NULL);

    }

    @Override
    protected void usrInitShowDatas() {

    }

    @Override
    public void onClick(View v) {
        switch (v.getId()) {
            case R.id.bt_open_watchDog:
                int b = Mcu7502.enableWatchdog();
                UsrLog.LOGD(TAG, "enable::" + b);
                Toast.makeText(this,"返回值：" + b, Toast.LENGTH_LONG).show();
                break;
            case R.id.bt_feed_dog:
                handler.post(feedDog);
                break;
            case R.id.bt_reset:
                int c = Mcu7502.resetMaster();
                Toast.makeText(this,"返回值：" + c,Toast.LENGTH_LONG).show();
                break;
            case R.id.bt_get_watchdog_status:
                int d = Mcu7502.getWatchdogStatus();
                Toast.makeText(this,"看门狗状态：" + d,Toast.LENGTH_LONG).show();
                break;
            case R.id.bt_get_version:
                int version = Mcu7502.getVersion();
                UsrLog.LOGD(TAG, "version:"+version);
                Toast.makeText(this,"版本号：" + version,Toast.LENGTH_LONG).show();
                break;
            case R.id.bt_close_watchDog:
                Toast.makeText(this,"返回值=：" + Mcu7502.disableWatchdog(),Toast.LENGTH_LONG).show();
                break;
            case R.id.bt_set_time:
                int time = Integer.parseInt(et_open_time.getText().toString().trim());
                int f = Mcu7502.setTime(time);
                UsrLog.LOGD(TAG, "time = " + time);
                Toast.makeText(this,"返回值：" + f,Toast.LENGTH_LONG).show();
                break;
            case R.id.bt_shutdown:
                Intent intent = new Intent();
                intent.setAction("android.intent.action.shutdown");
                sendBroadcast(intent);
                break;
            case R.id.bt_feed_dog_one_time:
                int feedTime = Integer.parseInt(et_feed_dog_time.getText().toString().trim());
                int g = Mcu7502.feetDog(feedTime);
                Toast.makeText(this,"喂狗返回值：" + g,Toast.LENGTH_LONG).show();
                break;
            case R.id.bt_test:{

               /* testHandler.post(testFunc);
                UsrLog.LOGD(TAG, "测试线程开启");*/
                break;
            }
            default:
                break;
        }
    }


    private Runnable testFunc = new Runnable() {
        @Override
        public void run() {
            testHandler.postDelayed(testFunc, 1000);
            UsrLog.LOGD(TAG, "testFunc run!!");
        }
    };

    private Runnable feedDog = new Runnable() {
        @Override
        public void run() {
            int a = Mcu7502.feetDog(30);
            handler.postDelayed(feedDog,10000);
            UsrLog.LOGD(TAG,"喂狗返回值：" + a);

        }
    };

    @Override
    protected void onDestroy() {
        Mcu7502.disableWatchdog();
        Mcu7502.close();
        handler.removeCallbacks(feedDog);
        super.onDestroy();
    }
}
